package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.*;
import com.xylink.sdk.face.AiFaceApi;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created with IntelliJ IDEA.
 * Description:
 * User: gzm
 * Date: 2019-03-04
 */
public class AiFaceTest {

//    private String enterpriseId= TestConfig.getInstance().getEnterpriseId();
//    private String token = TestConfig.getInstance().getToken();

    //pre
//    private String enterpriseId= "965af5a13523731e849d675c28b53b21caeec0d1";
//    private String token = "5640cdc9453b9a824ce52bba1690f7b76ea4d0569966b873b6044bd836ab7077";

    //prd
//    private String enterpriseId= "f3c422a7c36eac6c924ed2a50eb4f49f82b128de";
//    private String token = "2bf7837bfae26d4abbadd57808c5ab915737be67bdb98ae45fe62c1cfa44c6e5";

    //tx dev
    private String enterpriseId= "40260e9046bae2da238ac0b0c572326b91726a83";
    private String token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";

    @BeforeClass
    public static void setup() {
//        SDKConfigMgr.setServerHost("http://172.18.160.51:8080");
//        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
//        SDKConfigMgr.setServerHost("http://127.0.0.1:8081");
        SDKConfigMgr.setServerHost("https://devsdk.xylink.com");
    }

    @Test
    public void createUser(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            CreateFaceUserInfoReq createFaceUserInfoReq = new CreateFaceUserInfoReq();
            createFaceUserInfoReq.setUserAge(111);
            createFaceUserInfoReq.setUserDepartment("trsty");
            createFaceUserInfoReq.setUserIdentifyId("mynamemynamemyname");
            createFaceUserInfoReq.setUserName("mynamemynamemyname");
            createFaceUserInfoReq.setUserPhone("156007563821");
            createFaceUserInfoReq.setUserTitle("mynamemynamemyname");
            Result result = aiFaceApi.createUser(enterpriseId, token, createFaceUserInfoReq);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    @Test
    public void getUserInfoByUserId(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            Result result = aiFaceApi.getUserInfoByUserId(enterpriseId, token, 19978);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    @Test
    public void getUserInfoByUserIdBatch(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            List faceids = new ArrayList();
            faceids.add(19978);
            Result result = aiFaceApi.getUserInfoByUserIdBatch(enterpriseId, token, faceids);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    @Test
    public void getUserIdsByuserIdentifyId(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            Result result = aiFaceApi.getUserIdsByuserIdentifyId(enterpriseId, token, "mynamemynamemyname");
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void deleteUser(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            Result result = aiFaceApi.deleteUser(enterpriseId, token, 19978);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void updateUser(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            List<FaceUserInfo> userInfos = new ArrayList<FaceUserInfo>();
            FaceUserInfo faceUserInfo = new FaceUserInfo();
            faceUserInfo.setFaceUserId(19979);
            faceUserInfo.setUserDepartment("trsty");
            faceUserInfo.setUserIdentifyId("kkkkkkkmkmkmk");
            faceUserInfo.setUserName("kkkkkkkmkmkmk");
            faceUserInfo.setUserPhone("156007563821");
            faceUserInfo.setUserTitle("kkkkkkkmkmkmk");
            userInfos.add(faceUserInfo);
            Result result = aiFaceApi.updateUser(enterpriseId, token, userInfos);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void uploadFace(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            File file = new File("/Users/guozhenming/Desktop/tt.jpg");
            byte[] fileByte = Files.readAllBytes(file.toPath());
            FaceUploadReq faceUploadReq = new FaceUploadReq();
            faceUploadReq.setImage(fileByte);
            faceUploadReq.setFaceUserId(10252);
            faceUploadReq.setImageName("tt.jpeg");
            Result result = aiFaceApi.uploadFace(enterpriseId, token, faceUploadReq);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void deleteUserFace(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            UserFaceReq userFaceReq = new UserFaceReq();
            List<String> images = new ArrayList<String>();
            images.add("https://testdevfacedetection.xylink.com/MatrixImage/cb5958d4_fabf_49ab_ba92_54ee4f2d74bf/10252/6efd3939-8249-41d2-acdb-a9d11a830b3a.jpeg");
            userFaceReq.setImages(images);
            userFaceReq.setFaceUserId(10252);
            Result result = aiFaceApi.deleteUserFace(enterpriseId, token, userFaceReq);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void allUsersInfo(){
        AiFaceApi aiFaceApi=new AiFaceApi();
        try {
            Result result = aiFaceApi.allUsersInfo(enterpriseId, token, 0,111);
            System.out.println(result);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args){
        String ll = "external/v1/vods/2c9498247001647d01700ec6ba630f5d/query?enterpriseId=9f60163a5b60c2f64fb3d88f20ce0e7f397edd1a";
        Pattern pattern = Pattern.compile(".+/vods/\\w+/query.+");
        Matcher mm = pattern.matcher(ll);
        System.out.println(mm.matches());
    }
}
