package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.MeetingInfo;
import com.xylink.model.Pager;
import com.xylink.model.SdkCloudMeetingRoomRequest;
import com.xylink.model.SdkMeeting;
import com.xylink.model.SdkMeetingReq;
import com.xylink.sdk.conferenceControl.CreateMeetingApi;
import com.xylink.util.Result;
import com.xylink.util.SignUtil;
import org.junit.BeforeClass;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

import javax.xml.transform.Source;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import static org.junit.Assert.*;

/**
 * Created by changxiangyang on 2017/9/19.
 */
@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class CreateMeetingTest {

    private String roomNumber = "";
    private String enterpriseid= TestConfig.getInstance().getEnterpriseId();
    private String token = TestConfig.getInstance().getToken();

    @BeforeClass
    public static void setup() {
//        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
//        SDKConfigMgr.setServerHost("https://precloud.xylink.com");
//         SDKConfigMgr.setServerHost("https://testdevsdk.xylink.com");
        SDKConfigMgr.initSDKConfig("https://txdev-sdkapi.xylink.com","1U3GwtFH0VxpBKEllCm8EMCI","7jQsaCPE44P0v88rdl9rifFPGcMeT9Vx","12f52f01599d6b92cd5c46825e5b7926d23663b9");
        SDKConfigMgr.setSignType(SignUtil.SignType.SHA256);
       // SDKConfigMgr.setServerHost("http://127.0.0.1:8081");
    }

    //创建会议 TODO 会议室号不能重复
    @Test
    public void createMeeting(){
//        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
//        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        enterpriseid = "12f52f01599d6b92cd5c46825e5b7926d23663b9";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        CreateMeetingApi cma=new CreateMeetingApi();
        SdkMeetingReq smr=new SdkMeetingReq();
        smr.setMeetingName("room1");
        smr.setStartTime(System.currentTimeMillis() + (1000 * 60 * 2));
        smr.setDuration(1000 * 6000);
        smr.setMaxParticipantCount(5);
        smr.setAutoRecord(true);
        smr.setAutoMute(1);
//        smr.setMeetingNumber("910087653908");
//        smr.setRequirePassword(true);
//        smr.setPassword("090909");
        try {
            SdkMeeting meeting = cma.createMeeting(enterpriseid, token, smr);
            System.out.println(meeting);
            roomNumber = meeting.getMeetingNumber();
            // 成功示例：SdkMeeting{meetingNumber='910056972431', controlPassword='125102', password='', shareUrl='http://sdk.xylink.com/page/third/KUUSKTJC'}
        }catch (Exception e){
            System.out.println("testgetMeetingStatus--"+e);
        }
    }

    //创建会议
    @Test
    public void createMeetingV2(){
        enterpriseid = "12f52f01599d6b92cd5c46825e5b7926d23663b9";
        token = "b44fdd37912d4287aff29d5b8f16de77b0f38438da0af0e3ba55e8f332cab967";
        CreateMeetingApi cma=new CreateMeetingApi();
        SdkCloudMeetingRoomRequest sdkCloudMeetingRoomRequest=new SdkCloudMeetingRoomRequest();
        sdkCloudMeetingRoomRequest.setMeetingName("room1-dddd");
        sdkCloudMeetingRoomRequest.setStartTime(System.currentTimeMillis() + (1000 * 60 * 2));
        sdkCloudMeetingRoomRequest.setEndTime(System.currentTimeMillis() + (1000 * 60 * 3));
        sdkCloudMeetingRoomRequest.setMaxParticipant(4);
        sdkCloudMeetingRoomRequest.setAutoMute(0);
        Map<String, String> configs = new HashMap<String, String>();
        configs.put("autoRecord", "false");
        configs.put("recordAddDeviceName", "true");
        configs.put("smartMutePerson", "3");
        sdkCloudMeetingRoomRequest.setConfigs(configs);

        try {
            SdkMeeting meeting = cma.createMeetingV2(enterpriseid, token, sdkCloudMeetingRoomRequest);
            System.out.println(meeting);
            roomNumber = meeting.getMeetingNumber();
            // 成功示例：SdkMeeting{meetingNumber='910056972431', controlPassword='125102', password='', shareUrl='http://sdk.xylink.com/page/third/KUUSKTJC'}
        }catch (Exception e){
            System.out.println("testgetMeetingStatus--"+e);
        }
    }

    //创建会议
    @Test
    public void createMeetingByType(){
        enterpriseid = "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        CreateMeetingApi cma=new CreateMeetingApi();
        SdkCloudMeetingRoomRequest sdkCloudMeetingRoomRequest=new SdkCloudMeetingRoomRequest();
        sdkCloudMeetingRoomRequest.setMeetingName("testMeetingByType");
        sdkCloudMeetingRoomRequest.setRequirePassword(true);
        sdkCloudMeetingRoomRequest.setPassword("123456");
        sdkCloudMeetingRoomRequest.setControlPassword("123456");
        sdkCloudMeetingRoomRequest.setAutoMute(0);
        Map<String, String> configs = new HashMap<String, String>();
        configs.put("autoRecord", "false");
        configs.put("recordAddDeviceName", "false");
        configs.put("onlyRecordMainImage", "false");
        configs.put("smartMutePerson", "3");
        sdkCloudMeetingRoomRequest.setConfigs(configs);

        try {
            SdkMeeting meeting = cma.createMeetingByType(enterpriseid, token, sdkCloudMeetingRoomRequest);
            System.out.println(meeting);
            roomNumber = meeting.getMeetingNumber();
            // 成功示例：SdkMeeting{meetingNumber='910056972431', controlPassword='125102', password='', shareUrl='http://sdk.xylink.com/page/third/KUUSKTJC'}
        }catch (Exception e){
            System.out.println("testcreateMeetingByType--"+e);
        }
    }

    //按照会议号查询会议信息 TODO 云会议号保证有效
    @Test
    public void getMeetingInfo(){
        enterpriseid = "45c2a1dc40f45a04805fbba20b7d3ae2ea879bd4";
        token = "371eaa4ee1bf757236b9724614c7a5bd7d7c353f90571fa58f75944580b502ce";
        roomNumber = "910001071594";
//        enterpriseid = "a773aa1a4073a93e50d444f9a43940d4919f757e";
//        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
//        roomNumber = "910001071594";
        CreateMeetingApi cma=new CreateMeetingApi();

        Result<MeetingInfo> result=null;
        try {
            result=cma.getMeetingInfo(enterpriseid, token, roomNumber);
            System.out.println(result);
        }catch (IOException e){
            e.printStackTrace();
            fail(e.getMessage());
        }
    }
    //修改会议信息 TODO 云会议号保证有效
    @Test
    public void updateMeetingInfo(){
        enterpriseid = "45c2a1dc40f45a04805fbba20b7d3ae2ea879bd4";
        token = "371eaa4ee1bf757236b9724614c7a5bd7d7c353f90571fa58f75944580b502ce";
        roomNumber = "910001071594";
        CreateMeetingApi cma=new CreateMeetingApi();
        MeetingInfo meetingInfo=new MeetingInfo();
//        meetingInfo.setAutoMute(1);
//        meetingInfo.setSmartMutePerson(3);
        meetingInfo.setExpireTime(1619521247000l);
        meetingInfo.setSmartMutePerson(6);
        try {
            Result result = cma.updateMeetingInfo(enterpriseid, token, roomNumber,meetingInfo);
            System.out.println("update result:"+result);
//            assertEquals(200, result.getErrorStatus());
        }catch (IOException e){
            fail(e.getMessage());
        }
        try {
            Result<MeetingInfo> result = cma.getMeetingInfo(enterpriseid, token, roomNumber);
            System.out.println("更新后查询到的云会议室：" + result);
//            meetingInfo = result.getData();
//            assertEquals(result.getData().getAutoMute(), 2);
//            assertFalse(result.getData().isAutoRecord());
        } catch (IOException e) {
            fail(e.getMessage());
        }

//        meetingInfo.setMeettingRoomName("aagffgf7a");
//        meetingInfo.setAutoRecord(true);
//        try {
//            Result result = cma.updateMeetingInfo(enterpriseid, token, roomNumber,meetingInfo);
//            assertEquals(200, result.getErrorStatus());
//        }catch (IOException e){
//            fail(e.getMessage());
//        }
    }
    //批量查询会议信息 TODO 云会议号保证有效
    @Test
    public void getBatchMeetingInfo(){
        enterpriseid = "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        roomNumber = "9092806305";
        CreateMeetingApi cma=new CreateMeetingApi();
        String [] meetingRoomNos={roomNumber};
        try {
            Result<MeetingInfo[]> batchMeetingInfo = cma.getBatchMeetingInfo(enterpriseid, token, meetingRoomNos);
            System.out.println(batchMeetingInfo);
        }catch (IOException e){
            System.out.println("testGetBatchMeetingInfo--"+e);
        }
    }
    //删除会议 TODO 云会议号保证有效
    @Test
    public void xdeleteMeetingInfo(){
        enterpriseid = "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        roomNumber = "910011913753";
        CreateMeetingApi cma=new CreateMeetingApi();
        try {
            Result result= cma.deleteMeetingInfo(enterpriseid, token, roomNumber);
            System.out.println(result);
        }catch (IOException e){
            fail(e.getMessage());
        }
    }

    //查询某公司的sdk创建的会议
    @Test
    public void getSdkMeetingRooms(){
        CreateMeetingApi cma=new CreateMeetingApi();
        try {
            Result<MeetingInfo[]> sdkMeetingRooms = cma.getSdkMeetingRooms(enterpriseid, token);
            System.out.println(sdkMeetingRooms);
        }catch (IOException e){
            fail(e.getMessage());
        }
    }
    @Test
    public void getMeetingRoomsByType(){
        CreateMeetingApi cma=new CreateMeetingApi();
        try {
            Result result = cma.getMeetingRoomsByType(enterpriseid, token,0,10,"ENTERPRISE_CONFERENCE");
            System.out.println(result);
        }catch (IOException e){
            fail(e.getMessage());
        }
    }

    @Test
    public void getSdkMeetingRoomsByPage(){
        CreateMeetingApi cma=new CreateMeetingApi();
        String enterpriseid = "a773aa1a4073a93e50d444f9a43940d4919f757e";
        String token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        int page = 0;
        int size = 20;
        try {
            Result<Pager<MeetingInfo>> sdkMeetingRooms = cma.getSdkMeetingRooms(enterpriseid, token, page, size);
            System.out.println(sdkMeetingRooms);
        }catch (IOException e){
            fail(e.getMessage());
        }
    }
}
