package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.ExternalLoginRequest;
import com.xylink.sdk.user.UserValidateApi;
import com.xylink.sdk.vod.VodApi;
import com.xylink.util.AES256Util;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import static org.junit.Assert.fail;

/**
 * Created with IntelliJ IDEA.
 * Description:
 * User: gzm
 * Date: 2018-12-11
 */
public class VodTest {

    private String enterpriseid= TestConfig.getInstance().getEnterpriseId();
    private String token = TestConfig.getInstance().getToken();

    @BeforeClass
    public static void setup() {
        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
    }

    @Test
    public void videoDownload() {
        enterpriseid = "3f1f9b7ada2784ca8bc8a40bec559c3412dbdc1e";
        token = "57e05ae959544fba5b737a64c6250dde17089c6a4b73357160f3dd5512495609";
        VodApi vodApi = new VodApi();
        try {
            vodApi.videoDownload(enterpriseid, token, "2986993");
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getVodThumbnailurl() {
        enterpriseid = "3f1f9b7ada2784ca8bc8a40bec559c3412dbdc1e";
        token = "57e05ae959544fba5b737a64c6250dde17089c6a4b73357160f3dd5512495609";
        VodApi vodApi = new VodApi();
        try {
            Result result = vodApi.getVodThumbnailurl(enterpriseid, token, "2215036");
            System.out.println(result);
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }


    @Test
    public void getMeetingRoomVods() {
        enterpriseid = "45c2a1dc40f45a04805fbba20b7d3ae2ea879bd4";
        token = "371eaa4ee1bf757236b9724614c7a5bd7d7c353f90571fa58f75944580b502ce";
        VodApi vodApi = new VodApi();
        try {
            Result result = vodApi.getMeetingRoomVods(enterpriseid,token,"910024954537",0l,System.currentTimeMillis());
            System.out.println(result);
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getDownloadurl() throws IOException {
        enterpriseid = "45c2a1dc40f45a04805fbba20b7d3ae2ea879bd4";
        token = "371eaa4ee1bf757236b9724614c7a5bd7d7c353f90571fa58f75944580b502ce";
        String vodId = "5985718";
        VodApi vodApi = new VodApi();
        Result result = vodApi.getDownloadurl(enterpriseid, token, vodId);
        System.out.println(result);
    }

}
